#ifndef _TOOLKIT_H
#define _TOOLKIT_H

#include <stdbool.h>
#include <regex.h>
#include "liblist.h"

#define UT_ERROR        -1
#define UT_RETURN        0
#define UT_EXIT          1
#define UT_REDIRECT    301
#define UT_DENY_ACCESS 403

#define IU_EXISTS        0
#define IU_ISFILE        1
#define IU_ISDIR         2

typedef enum { ta_match_rewrite, ta_match_goto, ta_match_call, ta_match_return, 
               ta_match_exit, ta_match_skip, ta_call, ta_match_deny_access,
			   ta_match_redirect, ta_match_fastcgi, ta_skip, ta_requesturi} t_toolkit_action;
typedef enum { td_continue, td_return, td_exit } t_toolkit_done;

typedef struct type_toolkit_rule {
	regex_t pattern;
	t_toolkit_action action;
	t_toolkit_done done;
	int match_loop;
	char *parameter;
	int value;

	struct type_toolkit_rule *next;
} t_toolkit_rule;

typedef struct type_url_toolkit {
	char *toolkit_id;
	struct type_toolkit_rule *toolkit_rule;

	struct type_url_toolkit *next;
} t_url_toolkit;

t_url_toolkit *find_toolkit(char *toolkit_id, t_url_toolkit *url_toolkit);
bool toolkit_setting(char *key, char *value, t_url_toolkit *toolkit);
bool toolkit_rules_oke(t_url_toolkit *url_toolkit);
int use_toolkit(char *url, char *toolkit_id, t_url_toolkit *url_toolkit, char **new_url, char *website_root, char **fastcgi_server);

#endif
